"use strict";
cc._RF.push(module, '8b572F68x9DcrBvUR5lnLf9', 'PageViewTest');
// scripts/PageViewTest.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var PageViewTest = /** @class */ (function (_super) {
    __extends(PageViewTest, _super);
    function PageViewTest() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.m_pageviewNode = null;
        _this.text = 'hello';
        return _this;
        // update (dt) {}
    }
    // LIFE-CYCLE CALLBACKS:
    PageViewTest.prototype.onLoad = function () {
    };
    PageViewTest.prototype.OnPageViewEvent = function (event, custom) {
        var pageView = this.m_pageviewNode.getComponent(cc.PageView);
        var currPageIndex = pageView.getCurrentPageIndex();
        cc.log("OnPageViewEvent begin, page index=" + currPageIndex);
        if (currPageIndex != 1) { // page changed
            var pages = pageView.getPages();
            if (currPageIndex == 0) {
                var lastPage = pages[pages.length - 1];
                pageView.removePage(lastPage);
                pageView.insertPage(lastPage, 0); // add on top
                pageView.scrollToPage(1, 0);
                pageView.setCurrentPageIndex(1);
            }
            else if (currPageIndex == (pages.length - 1)) {
                var firstPage = pages[0];
                pageView.removePage(firstPage);
                pageView.addPage(firstPage); // add in bottom
                pageView.scrollToPage(1, 0);
                pageView.setCurrentPageIndex(1);
            }
        }
        else {
            cc.log("Page not change.");
        }
        cc.log("OnPageViewEvent end, page index=" + currPageIndex);
    };
    __decorate([
        property(cc.Node)
    ], PageViewTest.prototype, "m_pageviewNode", void 0);
    __decorate([
        property
    ], PageViewTest.prototype, "text", void 0);
    PageViewTest = __decorate([
        ccclass
    ], PageViewTest);
    return PageViewTest;
}(cc.Component));
exports.default = PageViewTest;

cc._RF.pop();